# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class FinancialMetrics(UniversalBaseModel):
    date: str = pydantic.Field()
    """
    The date of the financial metrics.
    """

    lifetime_gross_margin: typing.Optional[float] = pydantic.Field(default=None)
    """
    The lifetime gross margin, integrated over all time.
    """

    lifetime_operating_margin: typing.Optional[float] = pydantic.Field(default=None)
    """
    The lifetime operating margin, integrated over all time.
    """

    rule_of_40: typing.Optional[float] = pydantic.Field(default=None)
    """
    The rule of 40, defined as the year over year growth plus the operating margin, with slight smoothing to handle variations.
    """

    magic_number: typing.Optional[float] = pydantic.Field(default=None)
    """
    The magic number, defined as the revenue growth divided by the offset sales and marketing cost, with slight smoothing to handle variations.
    """

    burn_multiple: typing.Optional[float] = pydantic.Field(default=None)
    """
    The burn multiple, defined as the cash burn divided by the revenue growth, with slight smoothing to handle variations. The operating margin is used in place of the cash burn if the cash burn is not available. Not defined if the revenue growth is negative.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
