# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class WeatherComponents(UniversalBaseModel):
    stage: str = pydantic.Field()
    """
    The stage of the weather gauge
    """

    date: str = pydantic.Field()
    """
    The date of the data point
    """

    weather_gauge: typing.Optional[float] = pydantic.Field(default=None)
    """
    The values of the individual components of the weather gauge
    """

    actual_annualized: typing.Optional[float] = pydantic.Field(default=None)
    """
    The measured actual annualized fundraising amount for the stage in a rolling window, subset only to companies that have known amounts raised in the prior stage. The value is null for future dates beyond the last valid date of the indicator
    """

    potential_annualized: typing.Optional[float] = pydantic.Field(default=None)
    """
    The estimated present and past potential annualized fundraising amount for the stage in a rolling window, which measures the amount of fundraising one would expect under normal conditions, based on investment in the prior stage and accounting for exits. The value is null for future dates beyond the last valid date of the indicator
    """

    potential_annualized_forecast: typing.Optional[float] = pydantic.Field(default=None)
    """
    The estimated future potential annualized fundraising amount for the stage in a rolling window, which measures the amount of fundraising one would expect under normal conditions, based on investment in the prior stage and accounting for exits. The value is null for past dates and forecasted for future dates
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
